/*
 * Copyright (C) 2007, 2009, 2010 Apple Inc. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY APPLE COMPUTER, INC. ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL APPLE COMPUTER, INC. OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
 * OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE. 
 */

#include "config.h"
#if !HAVE(BINDINGS_ALL_IN_ONE)
#include "JSNode.h"

#include "Attr.h"
#include "CachedImage.h"
#include "CachedScript.h"
#include "CDATASection.h"
#include "Comment.h"
#include "Document.h"
#include "DocumentFragment.h"
#include "DocumentType.h"
#include "Entity.h"
#include "ExceptionCode.h"
#include "HTMLAudioElement.h"
#include "HTMLCanvasElement.h"
#include "HTMLElement.h"
#include "HTMLFrameElementBase.h"
#include "HTMLImageElement.h"
#include "HTMLLinkElement.h"
#include "HTMLNames.h"
#include "HTMLScriptElement.h"
#include "HTMLStyleElement.h"
#include "JSAttr.h"
#include "JSCDATASection.h"
#include "JSComment.h"
#include "JSDOMBinding.h"
#include "JSDocument.h"
#include "JSDocumentFragment.h"
#include "JSDocumentType.h"
#include "JSEventListener.h"
#include "JSHTMLElement.h"
#include "JSHTMLElementWrapperFactory.h"
#include "JSMathMLElementWrapperFactory.h"
#include "JSProcessingInstruction.h"
#include "JSShadowRoot.h"
#include "JSText.h"
#include "MathMLElement.h"
#include "Node.h"
#include "ProcessingInstruction.h"
#include "RegisteredEventListener.h"
#include "ShadowRoot.h"
#include "GCReachableRef.h"
#include "StyleSheet.h"
#include "StyledElement.h"
#include "Text.h"
#include <wtf/PassRefPtr.h>
#include <wtf/RefPtr.h>

#if ENABLE(SVG)
#include "JSSVGElementWrapperFactory.h"
#include "SVGElement.h"
#endif
#if ENABLE(RMAI)
#include "JSGalioWafer.h"
#include "GalioWafer.h"
#endif

using namespace JSC;

namespace WebCore {

using namespace HTMLNames;

static ALWAYS_INLINE bool isReachableFromDOM(Node& node, SlotVisitor& visitor)
{
    if (!node.isConnected()) {
		if (node.isElementNode()) {
			Element& element = toElement(node);

			// If a wrapper is the last reference to an image element
			// that is loading but not in the document, the wrapper is observable
			// because it is the only thing keeping the image element alive, and if
			// the element is destroyed, its load event will not fire.
			// FIXME: The DOM should manage this issue without the help of JavaScript wrappers.
			if (element.hasTagName(imgTag)) {
				if (static_cast<HTMLImageElement&>(element).hasPendingActivity())
					return true;
			}
#if ENABLE(VIDEO) && 0
			else if (element.hasTagName(audioTag)) {
				if (!static_cast<HTMLAudioElement&>(element).paused())
					return true;
			}
#endif
		}

		// If a node is firing event listeners, its wrapper is observable because
		// its wrapper is responsible for marking those event listeners.
		if (node.isFiringEventListeners())
			return true;

		if (GCReachableRefMap::contains(node)) {
			//if (UNLIKELY(reason))
			//    *reason = "Node is scheduled to be used in an async script invocation)";
			return true;
		}
	}

    return visitor.containsOpaqueRoot(root(node));
}

bool JSNodeOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    JSNode* jsNode = jsCast<JSNode*>(handle.get().asCell());
    return isReachableFromDOM(jsNode->wrapped(), visitor);
}

JSValue JSNode::insertBefore(ExecState* exec)
{
    JSValue newChildValue = exec->argument(0);
    auto* newChild = JSNode::toWrapped(newChildValue);
    if (UNLIKELY(!newChild))
        return JSValue::decode(throwArgumentTypeError(*exec, 0, "node", "Node", "insertBefore", "Node"));

    ExceptionCode ec = 0;
    if (UNLIKELY(!wrapped().insertBefore(*newChild, JSNode::toWrapped(exec->argument(1)), ec))) {
        setDOMException(exec, ec);
        return jsUndefined();
    }

    ASSERT(!ec);
    return newChildValue;
}

JSValue JSNode::replaceChild(ExecState* exec)
{
    auto* newChild = JSNode::toWrapped(exec->argument(0));
    JSValue oldChildValue = exec->argument(1);
    auto* oldChild = JSNode::toWrapped(oldChildValue);
    if (UNLIKELY(!newChild || !oldChild)) {
        if (!newChild)
            return JSValue::decode(throwArgumentTypeError(*exec, 0, "node", "Node", "replaceChild", "Node"));
        return JSValue::decode(throwArgumentTypeError(*exec, 1, "child", "Node", "replaceChild", "Node"));
    }

    ExceptionCode ec = 0;
    if (UNLIKELY(!wrapped().replaceChild(*newChild, *oldChild, ec))) {
        setDOMException(exec, ec);
        return jsUndefined();
    }

    ASSERT(!ec);
    return oldChildValue;
}

JSValue JSNode::removeChild(ExecState* exec)
{
    JSValue childValue = exec->argument(0);
    auto* child = JSNode::toWrapped(childValue);
    if (UNLIKELY(!child))
        return JSValue::decode(throwArgumentTypeError(*exec, 0, "child", "Node", "removeChild", "Node"));

    ExceptionCode ec = 0;
    if (UNLIKELY(!wrapped().removeChild(*child, ec))) {
        setDOMException(exec, ec);
        return jsUndefined();
    }

    ASSERT(!ec);
    return childValue;
}

JSValue JSNode::appendChild(ExecState* exec)
{
    JSValue newChildValue = exec->argument(0);
    auto newChild = JSNode::toWrapped(newChildValue);
    if (UNLIKELY(!newChild))
        return JSValue::decode(throwArgumentTypeError(*exec, 0, "node", "Node", "appendChild", "Node"));

    ExceptionCode ec = 0;
    if (UNLIKELY(!wrapped().appendChild(*newChild, ec))) {
        setDOMException(exec, ec);
        return jsUndefined();
    }

    ASSERT(!ec);
    return newChildValue;
}

JSScope* JSNode::pushEventHandlerScope(ExecState* exec, JSScope* node) const
{
    if (inherits(JSHTMLElement::info()))
        return jsCast<const JSHTMLElement*>(this)->pushEventHandlerScope(exec, node);
    return node;
}

void JSNode::visitAdditionalChildren(SlotVisitor& visitor)
{
    visitor.addOpaqueRoot(root(wrapped()));
}

static ALWAYS_INLINE JSValue createWrapperInline(ExecState* exec, JSDOMGlobalObject* globalObject, Node* node)
{
    ASSERT(node);
    ASSERT(!getCachedWrapper(globalObject, node));
    
    switch (node->nodeType()) {
        case Node::ELEMENT_NODE:
            if (node->isHTMLElement())
                return createJSHTMLWrapper(globalObject, toHTMLElement(node));
#if ENABLE(SVG)
            if (node->isSVGElement())
            	return createJSSVGWrapper(globalObject, static_cast<SVGElement*>(node));
#endif
#if ENABLE(MATHML)
            if (isMathMLElement(*node))
            	return createJSMathMLWrapper(globalObject, static_cast<MathMLElement*>(node));
#endif
			return CREATE_DOM_WRAPPER(globalObject, Element, node);
        case Node::ATTRIBUTE_NODE:
        	return CREATE_DOM_WRAPPER(globalObject, Attr, node);
        case Node::TEXT_NODE:
        	return CREATE_DOM_WRAPPER(globalObject, Text, node);
        case Node::CDATA_SECTION_NODE:
        	return CREATE_DOM_WRAPPER(globalObject, CDATASection, node);
        case Node::PROCESSING_INSTRUCTION_NODE:
        	return CREATE_DOM_WRAPPER(globalObject, ProcessingInstruction, node);
        case Node::COMMENT_NODE:
        	return CREATE_DOM_WRAPPER(globalObject, Comment, node);
        case Node::DOCUMENT_NODE:
            // we don't want to cache the document itself in the per-document dictionary
            return toJS(exec, globalObject, static_cast<Document*>(node));
        case Node::DOCUMENT_TYPE_NODE:
        	return CREATE_DOM_WRAPPER(globalObject, DocumentType, node);
        case Node::DOCUMENT_FRAGMENT_NODE:
#if ENABLE(SHADOW_DOM)
            if (node->isShadowRoot())
            	return CREATE_DOM_WRAPPER(globalObject, ShadowRoot, node);
#endif
			return CREATE_DOM_WRAPPER(globalObject, DocumentFragment, node);
            break;
#if ENABLE(RMAI)
        case Node::WAFER_NODE:
        	return CREATE_DOM_WRAPPER(globalObject, GalioWafer, node);
#endif
        default:
        	return CREATE_DOM_WRAPPER(globalObject, Node, node);
    }
}

JSValue createWrapper(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, Node* node)
{
    return createWrapperInline(exec, globalObject, node);
}

JSC::JSObject* getOutOfLineCachedWrapper(JSDOMGlobalObject* globalObject, Node* node)
{
    ASSERT(!globalObject->world()->isNormal());
    return globalObject->world()->wrappers().get(node);
}

JSValue toJSNewlyCreated(ExecState* exec, JSDOMGlobalObject* globalObject, Node* node)
{
    if (!node)
        return jsNull();
    
    return createWrapperInline(exec, globalObject, node);
}

void willCreatePossiblyOrphanedTreeByRemovalSlowCase(Node* root)
{
    ScriptState* scriptState = mainWorldScriptState(root->document().frame());
    if (!scriptState)
        return;

    JSLockHolder lock(scriptState);
    toJS(scriptState, static_cast<JSDOMGlobalObject*>(scriptState->lexicalGlobalObject()), root);
}

} // namespace WebCore
#endif
